#include <usplash-theme.h>
#include <usplash_backend.h>
#include "usplash_horizontale.h"

void left_right(struct usplash_theme* theme, struct usplash_pixmap* back, struct usplash_pixmap* fore, int percentage){
	int w = (back->width * percentage / 100);
	if(percentage < 0){/* Unloading */
        w = back->width + w;
	}
	/* Draw foreground on left on background */
        usplash_put_part(theme->progressbar_x, theme->progressbar_y, w, fore->height, fore, 0, 0);
        /* Draw background on right of foreground */
        usplash_put_part(theme->progressbar_x + w, theme->progressbar_y, back->width - w, back->height, back, w, 0);
}

void right_left(struct usplash_theme* theme, struct usplash_pixmap* back, struct usplash_pixmap* fore, int percentage){
	int w = (back->width * percentage / 100);
	if(percentage < 0){/* Unloading */
        w = back->width + w;
	}
	/* Draw background on left of foreground */
        usplash_put_part(theme->progressbar_x, theme->progressbar_y, back->width - w , back->height, back, 0, 0);
        /* Draw foreground on right of background */
        usplash_put_part(theme->progressbar_x + back->width - w , theme->progressbar_y, w, fore->height, fore, fore->width - w, 0);
}

void pulsate(struct usplash_theme* theme, struct usplash_pixmap* back, struct usplash_pixmap* fore){
    static int pulsate_step = 0;
    static int pulse_width = 56;
    static int step_width = 2;
    static int num_steps = 0;
    int x1;
    int x2;
    num_steps = (fore->width - pulse_width)/2;

    if(pulsate_step < num_steps/2+1){
        x1 = 2 * step_width * pulsate_step;
    }
    else{
        x1 = fore->width - pulse_width - 2 * step_width * (pulsate_step - num_steps/2+1);
    }
    x2 = x1 + pulse_width;

    /* Draw progress bar background on left side of foreground 'pulse' */
    usplash_put_part(theme->progressbar_x, theme->progressbar_y, x1, back->height, back, 0, 0);
    /* Draw progress bar foreground 'pulse' */
    usplash_put_part(theme->progressbar_x + x1, theme->progressbar_y, pulse_width, back->height, fore, x1, 0);
    /* Draw progress bar background on right side of foreground 'pulse' */
    usplash_put_part(theme->progressbar_x + x2, theme->progressbar_y, back->width - x2, back->height, back, x2, 0);

    pulsate_step = (pulsate_step + 1) % num_steps;
}
